4 # Copyright (C) 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21 echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
24 . "$UTIL_VSERVER_VARS"
26 . "$__PKGLIBDIR/vserver.functions"
32 $"Usage: $0 [--quiet|-q] [--debug] <cmd> [--] <vserver-name>* [--all] -- <params>+
34 Execute <cmd> <vserver> <params>* foreach vserver.
36 Report bugs to <$PACKAGE_BUGREPORT>."
40 function showVersion()
43 $"vsomething $PACKAGE_VERSION -- execute something for a set of vservers
44 This program is part of $PACKAGE_STRING
46 Copyright (C) 2005 Enrico Scholz
47 This program is free software; you may redistribute it under the terms of
48 the GNU General Public License. This program has absolutely no warranty."
54 declare -a vservers=()
56 tmp=$(getopt -o +q --long help,version,debug,quiet -n "$0" -- "$@") || exit 1
61 (--help) showHelp $0 ;;
62 (--version) showVersion ;;
64 (--quiet|-q) is_quiet=1 ;;
66 (*) echo $"vserver: internal error; arg=='$1'" >&2; exit 1;;
72 panic $"vsomething: no operation specified; try '--help' for more information"
75 title=${VSOMETHING_TITLE:-$cmd}
78 while test "$#" -ge 1; do
79 if getAllVserversByArg tmp "$1"; then
80 vservers=( "${vservers[@]}" "${tmp[@]}" )
84 (*) vservers=( "${vservers[@]}" "$1" )
91 test "${#vservers[@]}" -ne 1 || is_quiet=1
96 for i in "${vservers[@]}"; do
99 test -n "$is_quiet" || {
100 colorize bold echo -n "$title: operating on vserver "
101 colorize bold colorize emph echo "$i"
102 xtermTitle "$title: operating on vserver '$i' [$cnt/${#vservers[@]}]"
105 if test -n "$VSOMETHING_PKGMGMT"; then
106 if pkgmgmt.isInternal "$i"; then
107 $_VSERVER "$i" exec "$cmd" "$@"
110 ( _generateChbindOptions "$VSERVER_DIR"
111 $_VSERVER "$i" status &> /dev/null && \
112 CHBIND_CMD=( "$_CHBIND" "${CHBIND_OPTS[@]}" -- )
113 callInNamespace "$i" \
114 "$_VNAMESPACE" --new -- \
116 "$VSOMETHING_WORKER" "$i" "$@" )
124 test $res -eq 0 -o -n "$is_quiet" || {
125 colorize error echo -n $"$title failed on vserver '$i' with errorcode $res"
129 test -n "$is_quiet" || echo
132 test "$cnt" -ge 0 || warning $"No vservers specified"